-- PARTIE 3 : Programmation SQL
-- Julien Maître
-- Paul Narbonneau

DECLARE
    x NUMBER := 0; -- Cette variable ne sert à rien ?!
BEGIN
    FOR i IN 1..10
    LOOP
        IF MOD(i, 2) = 0
        THEN -- i is even
            INSERT INTO temp VALUES (i , i*100 , 'i is even');
        ELSE
            INSERT INTO temp VALUES (i , i*100 , 'i is odd');
        END IF;
        x := x + 1 ;
    END LOOP;
    COMMIT;
END;
/


-- Curseurs

DECLARE
    CURSOR c1 IS
        SELECT ename, empno, sal
        FROM emp
        ORDER BY sal DESC;

    my_ename VARCHAR2(10);
    my_empno NUMBER(4);
    my_sal NUMBER(7,2);

BEGIN
    OPEN c1;
    FOR i IN 1..5
    LOOP
        FETCH c1 INTO my_ename, my_empno, my_sal;
        EXIT WHEN c1%NOTFOUND;

        INSERT INTO temp VALUES (my_sal, my_empno, my_ename);
        COMMIT;
    END LOOP;
    CLOSE c1;
END;
/


-- PL/SQL versus SQL

CREATE TABLE RESULTAT (
    Code NUMBER PRIMARY KEY,
    Message CHAR(40)
);

CREATE OR REPLACE PROCEDURE make_RESULTAT IS
    CURSOR clients IS
        SELECT NUMCLI FROM CLI;
    cpt INTEGER := 0;

    CURSOR coms IS
        SELECT *
        FROM COM;
BEGIN
    FOR cli IN clients
    LOOP
        cpt := 0;
        FOR com IN coms
        LOOP
            if com.NUMCLI = cli.NUMCLI
            THEN
                cpt := cpt + 1;
            END IF;
        END LOOP;

        CASE
            WHEN cpt = 0 THEN
                INSERT INTO RESULTAT VALUES (cli.NUMCLI, 'Pas de commandes');
            WHEN cpt = 1 THEN
                INSERT INTO RESULTAT VALUES (cli.NUMCLI, TO_CHAR('Il y a une commande pour le client ' || cli.NUMCLI));
            ELSE
                INSERT INTO RESULTAT VALUES (cli.NUMCLI, TO_CHAR('Il y a ' || cpt || ' commandes pour le client ' || cli.NUMCLI));
        END CASE;
    END LOOP;
END;
/


INSERT INTO RESULTAT
    SELECT
        CLI.NUMCLI,
        COUNT(NUMCOM)
    FROM
        CLI LEFT OUTER JOIN
            COM
            ON
                CLI.NUMCLI = COM.NUMCLI
    GROUP BY CLI.NUMCLI
;



-- Q6
    SELECT
        FOU.*
    FROM
        FOU,
        PRO
    WHERE
        FOU.NumFou = PRO.NumFou
    AND
        PRO.prixUnit < 50
INTERSECT
    SELECT
        FOU.*
    FROM
        FOU,
        PRO
    WHERE
        FOU.NumFou = PRO.NumFou
    AND
        PRO.prixUnit > 400;

-- Q7
SELECT DISTINCT
    CLI.*
FROM
    CLI,
    COM
WHERE
    CLI.NumCli = COM.NumCli
AND (
        COM.AnCom = 1992
    OR
        COM.AnCom = 1993
);

-- Q8
SELECT *
FROM fou
WHERE numfou IN (SELECT numfou FROM PRO where prixunit = (SELECT min(prixunit) from PRO where nompro = 'Chef') and nompro = 'Chef');

-- Q9

SELECT nomfou
FROM fou
WHERE numfou IN (SELECT numfou FROM PRO where prixunit = (SELECT min(prixunit) from PRO where nompro = 'Chef') and nompro = 'Chef');

-- Q10

select fou.nomfou , pro.*
from fou , pro
where fou.numfou = pro.numfou
order by fou.nomfou, pro.nompro ;

-- Q11

select *
from fou , cli
where fou.nomfou = cli.nomcli;

SELECT *
FROM
    FOU
WHERE NomFou IN (
    SELECT NomCli
    FROM CLI
);

-- Q12

select *
from fou
where numfou not in ( select numfou from pro where prixunit > 50)


-- Q13

select *
from fou
where numfou not in ( select numfou from pro where prixunit < 50)

-- Q14

SELECT
    *
FROM
    FOU f
WHERE
    NOT EXISTS (
        -- Il n'existe pas de produit à moins de 10 (50)
        SELECT
            *
        FROM
            PRO p
        WHERE
            prixunit < 10
        AND
            -- Tel qu'il n'existe pas de produit attaché à ce fournisseur
            NOT EXISTS (
                SELECT
                    *
                FROM
                    PRO
                WHERE
                    pro.nompro = p.nompro
                AND
                    pro.numfou = f.numfou
            )
);


INSERT INTO PRO
VALUES (10000, 6, 'Blabla', 'A', 9);

INSERT INTO PRO
VALUES (10001, 6, 'Blabla2', 'A', 8);

INSERT INTO PRO
VALUES (10002, 8, 'Blabla', 'A', 6);

-- Q15

SELECT
    *
FROM
    CLI
WHERE
    NUMCLI NOT IN (
        SELECT
            NUMCLI
        FROM
            COM
        )
;
