-- PARTIE 4 : Experimentations sur la concurrence
-- Julien Maître
-- Paul Narbonneau

-- Q1
ALTER TABLE CLI
ADD solde number;

INSERT INTO CLI
VALUES (92, 'Joe', 'Allemagne', 0123456789, 1000.00);

-- Test 1 :
-- la transaction 2 ne voit pas la modification faite par la transaction 1 : elle n'a pas été validée.

-- Test 2 :
-- La transaction 2 voit la modification faite par la transaction 1 après son commit.

-- Test 3 :
-- La transaction 2 reste bloquée sur le dépot tant que la transaction 1 n'a pas commit.
--         => Modification d'une valeur modifiée et non validée.


-- Q2
-- Non, -3000 + 6000 => -1000 !!!! modification de la valeur entre la lecture et l'écriture => non sérialisable !

-- Q3
-- Pas de verrous long en lecture : T1 a pu modifié une valeur lue par T2 au lieu de rester bloquer en voulant poser son verrou
-- Pas de verrous court : T2 peut lire après l'écriture de T1 (qui a posé un verrous long en écriture) alors qu'il devrait se bloquer en voulant poser son verrou.

-- Q4
-- On a pu remarquer dans le test 1 que tant que la transaction n'etait pas commitée, la lecture de la transaction 2 gardait l'ancienne valeur, ce qui correspond a une lecture propre.
-- On a vu dans le test 3 que tant que la transaction 1 (qui fesait une operation d'ecriture) n'avait pas commit, la transaction 2 qui voulait ecrire ne pouvait pas se terminer, ce qui correspond a un verouillage long en ecriture.
-- On a vu lors du test 2 que la valeur lue au cours de la transaction 2 changeait car la transaction 1 la modifiait, ce qui montre bien que la lecture n'est pas reproductible.
-- Ce qui correspond aux propriétés du niveau lecture valide de la norme SQL si on ne tient pas compte des verrous court en lecture.

-- Q5
-- Oui, plusieurs valeurs existantes pour un même tuples après une opération de dépot/retrait non validée. (ce qui explique l'abscence de verrous en lecture)

-- Q6 - 7
-- select solde from CLI where NomCli ='Joe' for update;
-- FOR UPDATE pose un verrou sur les données de la requête. Si une autre transaction tente d'y accèder, elle se bloque.

-- Q8-9
-- Oracle ne donne pas accès au valeur plus récentes que la transaction. (comparaison de timestamp)
-- Si une valeur a été modifiée par une autre transaction, celle en cours se bloque si elle essaye de la modifier.
-- Si une valeur a été commit entre temps, la requête est rejetée, car non serializable.
-- En cas de bloquage + rollback, la transaction est débloquée et peut appliquer ses modifications.
-- pas de verrous en lecture mais multiversionning.

-- Q10 (bonus)
-- SERIALIZABLE vs READ-COMMITED
-- Si T1 serializable, T2 RC => mode RC
-- T1 écrit, T2 se bloque, T1 commit, T2 écrit, T2 commit

-- Si T1 serializable, T2 RC => mode serializable
-- T2 écrit, T1 se bloque, T2 commit, T1 erreur : non serializable

-- Si 2 transactions dans 2 modes différents, le mode utilisé globalement est celui de la transaction bloquée

